﻿/* ============================================================
* Author:       liubingsheng
* Time:         2016/11/29 14:52:25
* FileName:     RedisSystem
* Purpose:      Redis
* =============================================================*/

using System;
using System.Reflection;//反射

namespace Protocols
{
    /// <summary>
    /// 枚举注释的自定义属性类
    /// </summary>
    public class EnumDescriptionAttribute : Attribute
    {
        private string m_strDescription;
        public EnumDescriptionAttribute(string strPrinterName)
        {
            m_strDescription = strPrinterName;
        }

        public string Description
        {
            get { return m_strDescription; }
        }
    }

    /// <summary>
    /// Enum扩展
    /// </summary>
    public static class EnumExtenstion
    {
        /// <summary>
        /// 增加多个数据
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="lstValues"></param>
        public static string ToMsg(this System.Enum self)
        {
            FieldInfo fieldInfo = self.GetType().GetField(self.ToString());
            object[] attribArray = fieldInfo.GetCustomAttributes(false);
            EnumDescriptionAttribute attrib = (EnumDescriptionAttribute)attribArray[0];
            return attrib.Description;
        }
    }
}
